import 'package:fasekyc_flutter/src/model/person.dart';
import 'package:fasekyc_flutter/src/networking/graphql_api_provider.dart';

class PersonInfoAPI {
  GraphQLProvider _provider = GraphQLProvider();

  Future<PersonModel> getPersonInfo(String id, String token) async {
    GraphQLProvider _localProvider = GraphQLProvider(token: token);
    const String query = r'''
           query getPersonInfo(){
            getPersonInfo(){
              digital_id
              doc_number
              first_name_en
              last_name_en
              first_name_kh
              last_name_kh
              type
              gender
              date_of_birth
              country_code
              nationality
              issued_date
              expired_date
              issued_country
              optional_values
              place_of_birth
              current_address
              home_address
              identity_current_address
              identity_home_address
              current_profile
              status
            }
          }
    ''';
    Map<String, dynamic> variables = {"input": id};

    Map<String, dynamic> result =
        await _localProvider.send(query, variables: variables);
    var response = result['getPersonInfo'];
    return PersonModel.fromJson(response);
  }
}

PersonInfoAPI personInfoAPI = PersonInfoAPI();
