class PersonModel {
  PersonModel(
      {this.docNumber,
      this.firstNameEn,
      this.lastNameEn,
      this.firstNameKh,
      this.lastNameKh,
      this.type,
      this.gender,
      this.dateOfBirth,
      this.countryCode,
      this.nationality,
      this.issuedDate,
      this.expiredDate,
      this.issuedCountry,
      this.optionalValues,
      this.placeOfBirth,
      this.currentAddress,
      this.homeAddress,
      this.identityCurrentAddress,
      this.identityHomeAddress,
      this.currentProfile,
      this.digitalId,
      this.status});

  String? docNumber;
  String? digitalId;
  String? firstNameEn;
  String? lastNameEn;
  String? firstNameKh;
  String? lastNameKh;
  String? type;
  String? gender;
  DateTime? dateOfBirth;
  String? countryCode;
  String? nationality;
  DateTime? issuedDate;
  DateTime? expiredDate;
  String? issuedCountry;
  String? optionalValues;
  String? placeOfBirth;
  String? currentAddress;
  String? homeAddress;
  String? identityCurrentAddress;
  String? identityHomeAddress;
  String? currentProfile;
  String? status;

  factory PersonModel.fromJson(Map<String, dynamic> json) => PersonModel(
        docNumber: json["doc_number"],
        digitalId: json["digital_id"],
        firstNameEn: json["first_name_en"],
        lastNameEn: json["last_name_en"],
        firstNameKh: json["first_name_kh"],
        lastNameKh: json["last_name_kh"],
        type: json["type"],
        gender: json["gender"],
        dateOfBirth: DateTime.parse(json["date_of_birth"]),
        countryCode: json["country_code"],
        nationality: json["nationality"],
        issuedDate: json["issued_date"] == null ||
                json["issued_date"].toString().isEmpty
            ? DateTime.now()
            : DateTime.parse(json["issued_date"]),
        expiredDate: DateTime.parse(json["expired_date"]),
        issuedCountry: json["issued_country"],
        optionalValues: json["optional_values"],
        placeOfBirth: json["place_of_birth"],
        currentAddress: json["current_address"],
        homeAddress: json["home_address"],
        identityCurrentAddress: json["identity_current_address"],
        identityHomeAddress: json["identity_home_address"],
        currentProfile: json["current_profile"],
        status: json["status"],
      );

  Map<String, dynamic> toJson() => {
        "doc_number": docNumber,
        "first_name_en": firstNameEn,
        "last_name_en": lastNameEn,
        "first_name_kh": firstNameKh,
        "last_name_kh": lastNameKh,
        "type": type,
        "gender": gender,
        "date_of_birth": dateOfBirth?.toIso8601String(),
        "country_code": countryCode,
        "nationality": nationality,
        "issued_date": issuedDate?.toIso8601String(),
        "expired_date": expiredDate?.toIso8601String(),
        "issued_country": issuedCountry,
        "optional_values": optionalValues,
        "place_of_birth": placeOfBirth,
        "current_address": currentAddress,
        "home_address": homeAddress,
        "identity_current_address": identityCurrentAddress,
        "identity_home_address": identityHomeAddress,
        "current_profile": currentProfile,
      };
}
